
% Sean Costello et Sandra Brella, 2014
%-------------------------------------------------------------------------------
% SD demo 3: Un exemple de simulation du reservoir thermostatise de la fig. 2.33
% QUESTION: Simuler le reservoir thermostatise de la figure 2.33 pour:
% a) un saut de l'entree w
% b) un saut de la perturbation T_e
%-------------------------------------------------------------------------------

% Nettoyage de l'espace de travail
clear all; close all; clc;

%-------------------------------------------------------------------------------
% Definition des conditions initiales
%-------------------------------------------------------------------------------
% Voir fonction mydyn.m pour meilleure comprehension 
x0 = [200;300;250]; % [T, T_m, T_t]

%-------------------------------------------------------------------------------
% Integration Numerique de l'equation dynamique du reservoir thermostatise
%-------------------------------------------------------------------------------
odeoptions = odeset('RelTol',1e-10,'AbsTol',1e-10,'Stats','on'); 
tspan = [0,100]; %horizon temporel de la simulation en [s]
[tsim, xsim] = ode45(@(t,x)mydyn(t,x,myinput(t)),tspan,x0,odeoptions); 

%-------------------------------------------------------------------------------
% Affichage des resultats
%-------------------------------------------------------------------------------
figure('Name','Evolution des etats'),
plot(tsim, xsim)
legend('T', 'T_m', 'T_t')
xlabel('t [s]'), ylabel('Temperature [K]')
%
figure('Name','Evolution des entrees'),
% Obtention de u(t)
for i = 1:length(tsim),
    usim(:,i) = myinput(tsim(i)); 
end
plot(tsim, usim)
legend('w (kg s^{-1})', 'T_{i n} (K)', 'T_e (K)')
xlabel('t [s]'), ylabel('')


